/* @(#) All Right Reserved, Copyright (c) 1997 Australian National University */
/* @(#)                     Copyright (c) 1997 Fujitsu Laboratories Ltd. */
/*  */
/*        */
/*                        Permission Notice */
/*  */
/*                Australian National University */
/*                Canberra ACT 0200 Australia */
/*                           and */
/*                Fujitsu Laboratories Ltd. */
/*                4-1-1 Kamikodanaka Nakahara */
/*                Kawasaki 211-88 Japan */
/*  */
/*   Permission to use, copy, modify and distribute this software (including  */
/*   its documentation) without fee is hereby granted under the following terms */
/*   and conditions: */
/*  */
/*   1. This permission notice and all of the copyright notices in this */
/*      software must appear in all copies and derived versions of all */
/*      or a part of this software. */
/*  */
/*   2. Sales of this software, whether incorporated in other products as a */
/*      part thereof or not, is prohibited. */
/*  */
/*   3. On publication or presentation in any form of the results obtained */
/*      by use of this software, an explicit reference to this software and */
/*      its copyright owner shall be made. */
/*  */
/*   4. THIS SOFTWARE IS PROVIDED 'AS IS' AND THE AUSTRALIAN NATIONAL UNIVERSITY */
/*      AND FUJITSU LABORATORIES LTD. MAKE NO WARRANTIES, EITHER EXPRESSED OR */
/*      IMPLIED, AS TO ANY MATTER WHATSOEVER REGARDING THIS SOFTWARE,  */
/*      INCLUDING, WITHOUT LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS */
/*      FOR ANY PARTICULAR PURPOSE. */
/*      IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY OR FUJITSU */
/*      LABORATORIES LTD. BE LIABLE FOR ANY CLAIM FROM A THIRD PARTY, OR */
/*      FOR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES WHATSOEVER RESULTING */
/*      FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, */
/*      NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION */
/*      WITH THE USE, COPYING OR MODIFICATION OF THIS SOFTWARE. */
/*  */

/************************************************************************/
/*	LocMat: definitions for cell matrix data structures		*/
/************************************************************************/
/* SCCS INFO @(#)LocMat.c 4.3         last modified P. Strazdins, 97/03/14
   first created: P. Strazdins 96/01/15
*/
/*  compilation: macro FDATATYPE must be defined;
 */
#include "FDATASetUp.h"
#include "LocMat.h"

LocMat MkLocMat( A, RInc, CInc )
  FDATA *A; int RInc, CInc;
{ LocMat M; LM_Init( M, A, RInc, CInc );
  return(M);
}  

LocMat LocSubMat( M, i, j )
  LocMat M; int i, j;
{ LM_ADR(M) = LM_Index(M, i, j);
  return(M);
}  

LocMat LocMatTrans( M )
  LocMat M;
{ SWAP(int, LM_RInc(M), LM_CInc(M));
  return(M);
}  

#include <stdio.h>
#include "FDATAAssert.h"

void MatPrint(Name, M, N, A)
  int M, N; char *Name; LocMat A;
{ int i, j, RIncA=LM_RInc(A), CIncA=LM_CInc(A); FDATA *Ax = LM_ADR(A);
  COMMON_ASSERT_TR(
    (TraceStr, "(%2s,%dx%d,a%d %d %d)", Name, M, N, FD_ADR(Ax), RIncA, CIncA),
    1, 0, "MatPrint", 5, TRACE_ALL
  );
  for (i=0; i < M && N>0; i++) {
    PrintLinePrefix();	
    if (i==0) 
      printf("%s ", Name);
    else 
      for (j=0; j < strlen(Name)+1; j++)
        putchar(' ');  	
    for (j=0; j < N; j++)
#if (FDATATYPE == SINGLE || FDATATYPE == DOUBLE)
      printf("%3.3f ", Ax[i*RIncA+j*CIncA]);
#else  
      printf("(%3.2f,%3.2f) ", Ax[i*RIncA+j*CIncA].r ,  Ax[i*RIncA+j*CIncA].i);
#endif /*FDATATYPE*/ 
    printf("\n");
  }
} /* MatPrint() */

