/* @(#) All Right Reserved, Copyright (c) 1997 Australian National University */
/* @(#)                     Copyright (c) 1997 Fujitsu Laboratories Ltd. */
/*  */
/*        */
/*                        Permission Notice */
/*  */
/*                Australian National University */
/*                Canberra ACT 0200 Australia */
/*                           and */
/*                Fujitsu Laboratories Ltd. */
/*                4-1-1 Kamikodanaka Nakahara */
/*                Kawasaki 211-88 Japan */
/*  */
/*   Permission to use, copy, modify and distribute this software (including  */
/*   its documentation) without fee is hereby granted under the following terms */
/*   and conditions: */
/*  */
/*   1. This permission notice and all of the copyright notices in this */
/*      software must appear in all copies and derived versions of all */
/*      or a part of this software. */
/*  */
/*   2. Sales of this software, whether incorporated in other products as a */
/*      part thereof or not, is prohibited. */
/*  */
/*   3. On publication or presentation in any form of the results obtained */
/*      by use of this software, an explicit reference to this software and */
/*      its copyright owner shall be made. */
/*  */
/*   4. THIS SOFTWARE IS PROVIDED 'AS IS' AND THE AUSTRALIAN NATIONAL UNIVERSITY */
/*      AND FUJITSU LABORATORIES LTD. MAKE NO WARRANTIES, EITHER EXPRESSED OR */
/*      IMPLIED, AS TO ANY MATTER WHATSOEVER REGARDING THIS SOFTWARE,  */
/*      INCLUDING, WITHOUT LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS */
/*      FOR ANY PARTICULAR PURPOSE. */
/*      IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY OR FUJITSU */
/*      LABORATORIES LTD. BE LIABLE FOR ANY CLAIM FROM A THIRD PARTY, OR */
/*      FOR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES WHATSOEVER RESULTING */
/*      FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, */
/*      NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION */
/*      WITH THE USE, COPYING OR MODIFICATION OF THIS SOFTWARE. */
/*  */

/************************************************************************/
/*                     MachineParams		                        */
/************************************************************************/
/* SCCS INFO @(#)MachineParams.c 1.2         last modified P. Strazdins, 96/06/11
   first created: P. Strazdins 92/01
*/
/* Implementation of modifieable DBLAS machine-dependent parameters.
 * The arrays are statically defined must be changed if the the values 
 * of the _NUM constants change or if NUM_MACH_PARAMS changes.
 */	
/************************************************************************/

#include "string.h"
#undef TUNE
#include "MachineParams.h"


/* these arrays should have exactly NUM_MACH_PARAMS entries,
   whose order corresponds to the value of the respective _NUM indices */ 
int MachParamVec[] = {
	CACHESIZE,			CACHE_ASSOC,
	CACHE_LINE_SIZE,		OPT_MSG_SIZE,
	MAX_DBLAS_WS_SIZE,		MIN_VECSIZE,
	INNER_VECSIZE,			OUTER_VECSIZE,
	MINOR_OUTER_VECSIZE,		K0_MINOR_OUTER_VECSIZE,
	MINOR_OUTER_VECSIZE_K0,		PAR_INNER_VECSIZE,
	PAR_INNER_VECSIZE_TRSM,		PAR_OUTER_VECSIZE,
	PAR_INNER_VECSIZE_TRSM_MIN
}; 		

static char *MnemVals[] = {
  	CACHESIZE_MNEM, 		CACHE_ASSOC_MNEM, 	
	CACHE_LINE_SIZE_MNEM,		OPT_MSG_SIZE_MNEM,
	MAX_DBLAS_WS_SIZE_MNEM,		MIN_VECSIZE_MNEM,
	INNER_VECSIZE_MNEM,		OUTER_VECSIZE_MNEM,
	MINOR_OUTER_VECSIZE_MNEM,	K0_MINOR_OUTER_VECSIZE_MNEM,
	MINOR_OUTER_VECSIZE_K0_MNEM,	PAR_INNER_VECSIZE_MNEM,
	PAR_INNER_VECSIZE_TRSM_MNEM,	PAR_OUTER_VECSIZE_MNEM,
	PAR_INNER_VECSIZE_TRSM_MIN_MNEM
};

int MachParamVal( ParamMnem )
  char *ParamMnem;
{ int i=0;
  while (i < NUM_MACH_PARAMS && strcmp(ParamMnem, MnemVals[i])!=0)
    i++;
  if (i==NUM_MACH_PARAMS)
    i=-1;
  return(i);
} /* MachParamVal() */
