/* @(#) All Right Reserved, Copyright (c) 1997 Australian National University */
/* @(#)                     Copyright (c) 1997 Fujitsu Laboratories Ltd. */
/*  */
/*        */
/*                        Permission Notice */
/*  */
/*                Australian National University */
/*                Canberra ACT 0200 Australia */
/*                           and */
/*                Fujitsu Laboratories Ltd. */
/*                4-1-1 Kamikodanaka Nakahara */
/*                Kawasaki 211-88 Japan */
/*  */
/*   Permission to use, copy, modify and distribute this software (including  */
/*   its documentation) without fee is hereby granted under the following terms */
/*   and conditions: */
/*  */
/*   1. This permission notice and all of the copyright notices in this */
/*      software must appear in all copies and derived versions of all */
/*      or a part of this software. */
/*  */
/*   2. Sales of this software, whether incorporated in other products as a */
/*      part thereof or not, is prohibited. */
/*  */
/*   3. On publication or presentation in any form of the results obtained */
/*      by use of this software, an explicit reference to this software and */
/*      its copyright owner shall be made. */
/*  */
/*   4. THIS SOFTWARE IS PROVIDED 'AS IS' AND THE AUSTRALIAN NATIONAL UNIVERSITY */
/*      AND FUJITSU LABORATORIES LTD. MAKE NO WARRANTIES, EITHER EXPRESSED OR */
/*      IMPLIED, AS TO ANY MATTER WHATSOEVER REGARDING THIS SOFTWARE,  */
/*      INCLUDING, WITHOUT LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS */
/*      FOR ANY PARTICULAR PURPOSE. */
/*      IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY OR FUJITSU */
/*      LABORATORIES LTD. BE LIABLE FOR ANY CLAIM FROM A THIRD PARTY, OR */
/*      FOR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES WHATSOEVER RESULTING */
/*      FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, */
/*      NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION */
/*      WITH THE USE, COPYING OR MODIFICATION OF THIS SOFTWARE. */
/*  */

/************************************************************************/
/*         DBLAS interface to P_TRAN()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_TRAN.c 1.2         last modified P. Strazdins, 97/05/22
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_TRAN=0;		/* to indicate if P_TRAN is linked in*/
#endif

#define dA DMV[1]
#define dC DMV[0]
#define dA_ DMS[1]
#define dC_ DMS[0]

void P_TRAN (m, n, alpha, A, ia, ja, desc_A, beta, 
	     C, ic, jc, desc_C )
  int *m, *n;
  FDATA *alpha, A[], *beta, C[];  	int *ia, *ja, *ic, *jc;
  int desc_A[], desc_C[];
{ int ParamErr = 0;
  DistMatAlloc(2);                      int Align[1];
  int NoOuterErrCheck_ = NoOuterErrCheck;
  
  if (!DimOK(*m)) 			ParamErr = 1;   
  else if (!DimOK(*n)) 			ParamErr = 2;
  else {
    DMLocSetUp(1, A, desc_A, dA_, dA);
    DMLocSetUp(0, C, desc_C, dC_, dC);
    ParamErr = PDesc2ChkConv(*m, *n, *ic, *jc, desc_C, *ia, *ja, desc_A, 
  	     	             1207, DMV, Align);
    if (ParamErr==0) {
      if (!AlignM) 			ParamErr = 7;
      else if (!Dim_BCompat(DM_D1(dC), DM_D0(dA)))	ParamErr = 7;
    }
  }
            
  ERROR_CHECK_TR(
    (TraceStr, "(%d,%d,%1.1f,a%d,%d,%d,_,%1.1f,a%d,%d,%d,_)", 
     *m, *n, *alpha, FD_ADR(A), *ia, *ja, *beta, FD_ADR(C), *ic, *jc), 
    -ParamErr, "TRAN", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;  /* suppress checking in D_ScaleAdd() */
  D_ScaleAdd(*m, *n, *alpha, dA, *beta, dC); 
  NoOuterErrCheck = NoOuterErrCheck_;
  TRACE_EXIT;
}  /* P_TRAN()*/

